<?php
session_start();
/*
Plugin Name: FAN Courier
Plugin URI: http://www.fancourier.ro
Description: Modul de livrare FAN Curier 
Version: 1.0.0
Author: FAN Courier
Author URI: http://fancourier.ro
License: GPL2
*/

   if(!defined('ABSPATH')){
	exit; //Exit if accessed directly (for safety)
	
    }

if (in_array('woocommerce/woocommerce.php', apply_filters('active_plugins', get_option('active_plugins')))) {
    $dir = plugin_dir_path(__FILE__);
    
  
    function fan_courier_init(){
    
    class WC_FAN_Courier extends WC_Shipping_Method {
	 
        function __construct() {
	    
	    
            global $woocommerce;            
            unset($woocommerce->session->subtotal);
                                    
            $this->type = addslashes($_POST['payment_method']);
            $this->id = 'fan_courier';
            $this->method_title = 'FAN Courier';
	    $this->method_description = __( 'Stimate client, puteti obtine informatii pentru configurare la adresa de email: <a href="mailto:selfawb@fancourier.ro">selfawb@fancourier.ro</a><br>
					   Va multumim pentru ca folositi serviciile FAN Courier.', 'woocommerce' );
            $this->title = 'FAN Courier';
	    $this->enabled  = "yes";
	    $this->init();
            
           
        }                
 
	
	
        function init_form_fields() {
            $this->form_fields = array(

		'enabled' => array(
					'title' 		=> __( 'Activare/Dezactivare', 'woocommerce' ),
					'type' 			=> 'checkbox',
					'label' 		=> __( 'A se utiliza modulul FAN Courier', 'woocommerce' ),
				),
		
		'FAN_security' => array(
					'title' 		=> __( 'Securitate: ', 'woocommerce' ),
					'type' 			=> 'title',		
				),
		
                'FAN_clientID' => array(
					'title' 		=> __('ID Client *', 'woocommerce'),
					'type' 			=> 'text',
					'default'		=> __('', 'woocommerce'),
					'description' 		=> __( 'Client ID oferit de FAN Courier', 'woocommerce' ),
					'desc_tip'		=> true,
					'required'		=> true,
				),
		
		
                'FAN_clientAccount' => array(
					'title' 		=> __('Cont utilizator *', 'woocommerce'),
					'type' 			=> 'text',
					'default'		=> __('', 'woocommerce'),
					'description' 		=> __( 'Cont utilizator selfAWB', 'woocommerce' ),
					'desc_tip'		=> true,
				
				),
		
                'FAN_password' => array(
					'title' 		=> __('Parola *', 'woocommerce'),
					'type' 			=> 'text',
					'default'		=> __('', 'woocommerce'),
					'description' 		=> __( 'Parola cont selfAWB', 'woocommerce' ),
					'desc_tip'		=> true,
					
				),
		
		'FAN_confirmAWB' => array(
					'title' 		=> __( 'Confirmare AWB de catre Admin', 'woocommerce' ),
					'type' 			=> 'select',
					'label' 		=> __( '', 'woocommerce' ),
					'default' 		=> 'no',
					'css' 			=> 'width:350px;',
					'options'		=> array(
						'no' 	=> __('No', 'woocommerce'),
						'yes' 	    => __('Yes', 'woocommerce')
					),
					
				),
		
		'FAN_AWBoptions' => array(
					'title' 		=> __( 'Optiuni AWB: ', 'woocommerce' ),
					'type' 			=> 'title',
					  
				),
		
                'FAN_parcelShipping' => array(
					'title' 		=> __('Expediere colete', 'woocommerce'),
					'type' 			=> 'select',
					'label' 		=> __( '', 'woocommerce' ),
					'default' 		=> 'no',
					'css' 			=> 'width:350px;',
					'options'		=> array(
						'no' 	=> __('No', 'woocommerce'),
						'yes' 	    => __('Yes', 'woocommerce')
					),
					
				),
		
                'FAN_numberOfParcels' => array(
					'title' 		=> __('Numar pachete / AWB *', 'woocommerce'),
					'type' 			=> 'price',
					'default' 		=> '1',
					'description' 		=> __( 'Introduceti un numar intreg. Exemplu: 1 -daca expediati un pachet/ AWB ', 'woocommerce' ),
					'desc_tip'		=> true ,
				),
		
                'FAN_paymentAtDestination' => array(
					'title' 		=> __('Plata AWB la destinatie', 'woocommerce'),
					'type' 			=> 'select',
					'default' 		=> 'no',
					'css' 			=> 'width:350px;',
					'options'		=> array(
						'no' 	    => __('No', 'woocommerce'),
						'yes' 	    => __('Yes', 'woocommerce')
					),
					
				),
		
                'FAN_priceWithoutVAT' => array(
					'title' 		=> __('Afisare pret fara TVA', 'woocommerce'),
					'type' 			=> 'select',
					'default' 		=> 'no',
					'css' 			=> 'width:350px;',
					'options'		=> array(
						'no' 	    => __('No', 'woocommerce'),
						'yes' 	    => __('Yes', 'woocommerce')
					),
					
				),
		
                 'FAN_priceForExtraKm' => array(
					'title' 		=> __('Afisare pret doar Km suplimentari', 'woocommerce'),
					'type' 			=> 'select',
					'default' 		=> 'no',
					'description' 		=> __( 'In cazul acestei optiuni este necesar sa se seteze <strong>Plata AWB la destinatie - NU <strong> si <strong>Adaugare taxa transp. la ramburs - DA</strong>', 'woocommerce' ),
					'desc_tip'		=> true ,
					'css' 			=> 'width:350px;',
					'options'		=> array(
						'no' 	    => __('No', 'woocommerce'),
						'yes' 	    => __('Yes', 'woocommerce')
					),
					
				),
		 
		 'FAN_hideShippingRate' => array(
			'title' 		=> __('Ascundere taxa transport', 'woocommerce'),
			'type' 			=> 'select',
			'default' 		=> 'no',
			'css' 			=> 'width:350px;',
			'options'		=> array(
				'no' 	    => __('No', 'woocommerce'),
				'yes' 	    => __('Yes', 'woocommerce')
			),
			
			       ),
		 
		 'FAN_freeShippingMinimumAmount' => array(
			    'title' 		=> __('Suma minima transport gratuit', 'woocommerce'),
			    'type' 		=> 'price',
			    	
		    ),
		 
		'FAN_bucFixedAmount' => array(
			    'title' 		=> __('Valoare fixa pentru transport in Bucuresti', 'woocommerce'),
			    'type' 		=> 'price',
			    	
		    ),
		   
		'FAN_countryFixedAmount' => array(
			    'title' 		=> __('Valoare fixa pentru transport in tara', 'woocommerce'),
			    'type' 		=> 'price',
			    	
		    ),
		   
		'FAN_reimbursementOptions' => array(
					'title' 		=> __( 'Optiuni ramburs: ', 'woocommerce' ),
					'type' 			=> 'title',  
		    ),
		   
		'FAN_askForRbsGoodsValue' => array(
			'title' 		=> __('Solicitare ramburs valoare marfa', 'woocommerce'),
			'type' 			=> 'select',
			'default' 		=> 'yes',
			'css' 			=> 'width:350px;',
			'options'		=> array(
				'no' 	    => __('No', 'woocommerce'),
				'yes' 	    => __('Yes', 'woocommerce')
				),
			
		    ),
		   
		'FAN_addShipTaxToRbs' => array(
			'title' 		=> __('Adaugare taxa transp. la ramburs', 'woocommerce'),
			'type' 			=> 'select',
			'default' 		=> 'yes',
			'css' 			=> 'width:350px;',
			'options'		=> array(
				'no' 	    => __('No', 'woocommerce'),
				'yes' 	    => __('Yes', 'woocommerce')
				),
			
		    ),
		'FAN_askForRbsInBankAccount' => array(
			'title' 		=> __('Solicitare ramburs in cont bancar', 'woocommerce'),
			'type' 			=> 'select',
			'default' 		=> 'yes',
			'css' 			=> 'width:350px;',
			'options'		=> array(
				'no' 	    => __('No', 'woocommerce'),
				'yes' 	    => __('Yes', 'woocommerce')
				),
			
		    ),
		   
		'FAN_rbsPaymentAtDestination' => array(
			'title' 		=> __('Plata ramburs la destinatie', 'woocommerce'),
			'type' 			=> 'select',
			'default' 		=> 'no',
			'description' 		=> __( 'Nu se aplica pentru serviciile de tip Cont Colector', 'woocommerce' ),
			'desc_tip'		=> true,
			'css' 			=> 'width:350px;',
			'options'		=> array(
				'no' 	    => __('No', 'woocommerce'),
				'yes' 	    => __('Yes', 'woocommerce')
				),
			
		    ),
		   
		'FAN_insurance' => array(
					'title' 		=> __( 'Asigurare: ', 'woocommerce' ),
					'type' 			=> 'title',  
		    ),
		   
		'FAN_askForShipInsurance' => array(
			'title' 		=> __('Solicitare asigurare de transport', 'woocommerce'),
			'type' 			=> 'select',
			'default' 		=> 'no',
			'css' 			=> 'width:350px;',
			'options'		=> array(
				'no' 	    => __('No', 'woocommerce'),
				'yes' 	    => __('Yes', 'woocommerce')
				),
			
		    ),
		    
		'FAN_includeProductsCode' => array(
			'title' 		=> __('Include cod produse la continut', 'woocommerce'),
			'type' 			=> 'select',
			'default' 		=> 'no',
			'css' 			=> 'width:350px;',    
			'options'		=> array(
				'no' 	    => __('No', 'woocommerce'),
				'yes' 	    => __('Yes', 'woocommerce')
				),
			
		    ),
		     
		'FAN_observations' => array(
					'title' 		=> __( 'Observatii si note: ', 'woocommerce' ),
					'type' 			=> 'title',  
		    ),
		    
		    
		'FAN_obsOnAWB' => array(
					'title' 		=> __('Observatii (imprimare pe AWB)', 'woocommerce'),
					'type' 			=> 'text',
					'default'		=> __('', 'woocommerce'),										
				),
		     
		'FAN_contactPerson' => array(
					'title' 		=> __('Persoana de contact', 'woocommerce'),
					'type' 			=> 'text',
					'default'		=> __('', 'woocommerce'),										
				),
		     
		'FAN_availableServices' => array(
					'title' 		=> __( 'Servicii specifice disponibile: ', 'woocommerce' ),
					'type' 			=> 'title',  
		    ),
		    
		/*'FAN_redCodeOption' => array(
			'title' 		=> __('Afisare optiune RedCode', 'woocommerce'),
			'type' 			=> 'select',
			'default' 		=> 'no',
			'css' 			=> 'width:350px;',
			'options'		=> array(
				'no' 	    => __('No', 'woocommerce'),
				'yes' 	    => __('Yes', 'woocommerce')
				),
			
		    ),
		    
		'FAN_expressLocoOption' => array(
			'title' 		=> __('Afisare optiune ExpressLoco', 'woocommerce'),
			'type' 			=> 'select',
			'default' 		=> 'no',
			'css' 			=> 'width:350px;',
			'options'		=> array(
				'no' 	    => __('No', 'woocommerce'),
				'yes' 	    => __('Yes', 'woocommerce')
				),
			
		    ),*/
		    
		'FAN_servicesOptions' => array(
					'title' 		=> __( 'Optiuni servicii: ', 'woocommerce' ),
					'type' 			=> 'title',  
		    ),
		    
		'FAN_openOnDelivery' => array(
			'title' 		=> __('Deschidere la livrare', 'woocommerce'),
			'type' 			=> 'select',
			'default' 		=> 'no',
			'css' 			=> 'width:350px;',
			'description' 		=> __( 'In cadrul acestei optiuni este necesar sa se seteze <strong>Plata AWB la destinatie - NU <strong>', 'woocommerce' ),
			'desc_tip'		=> true,
			'options'		=> array(
				'no' 	    => __('No', 'woocommerce'),
				'yes' 	    => __('Yes', 'woocommerce')
				),
			
		    ),
		
		'FAN_epod' => array(
			'title' 		=> __('Utilizare optiune ePOD', 'woocommerce'),
			'type' 			=> 'select',
			'default' 		=> 'no',
			'css' 			=> 'width:350px;',			
			'desc_tip'		=> false,
			'options'		=> array(
				'no' 	    => __('No', 'woocommerce'),
				'yes' 	    => __('Yes', 'woocommerce')
				),
			
		    ),
	    );
        }
        
	
	
	function init() {
				// Load the settings API
				$this->init_form_fields(); // This is part of the settings API. Override the method to add your own settings
				$this->init_settings(); // This is part of the settings API. Loads settings you previously init.
				
				// Save settings in admin if you have any defined
				add_action( 'woocommerce_update_options_shipping_' . $this->id, array( $this, 'process_admin_options' ) );
			}
	
	
        public function admin_options() {
	    
            $url = plugins_url();
           
           
            echo '<h3>FAN Courier - Romania</h3>
		    <p>Stimate client, puteti obtine informatii despre configurare la adresa de email: <a href="mailto:selfawb@fancourier.ro" style="text-decoration:none;">selfawb@fancourier.ro</a></p>
		    <p>Va multumim pentru ca folositi serviciile FAN Courier.</p>
		    
		<table class="form-table">';
	   
        	$this->generate_settings_html();
	    
            echo '</table>';
        }
        
	
		
        function calculate_shipping($package = array()){
           
                global $wpdb,$woocommerce;
		
	
                // ------------ campuri modul START ------------------

                $FAN_clientId = $this->get_option('FAN_clientID');
                $FAN_clientAccount = $this->get_option('FAN_clientAccount');
                $FAN_password = $this->get_option('FAN_password');
		$FAN_confirmAWB = $this->get_option('FAN_confirmAWB');
		$FAN_parcelShipping = $this->get_option('FAN_parcelShipping');		
		$FAN_numberOfParcels = $this->get_option('FAN_numberOfParcels');
		$FAN_paymentAtDestination = $this->get_option('FAN_paymentAtDestination');
		$FAN_priceWithoutVAT = $this->get_option('FAN_priceWithoutVAT');
		$FAN_priceForExtraKm = $this->get_option('FAN_priceForExtraKm');
		$FAN_hideShippingRate = $this->get_option('FAN_hideShippingRate');
		$FAN_freeShippingMinimumAmount = $this->get_option('FAN_freeShippingMinimumAmount');
		$FAN_bucFixedAmount = $this->get_option('FAN_bucFixedAmount');
		$FAN_countryFixedAmount = $this->get_option('FAN_countryFixedAmount');
		$FAN_askForRbsGoodsValue = $this->get_option('FAN_askForRbsGoodsValue');
		$FAN_addShipTaxToRbs = $this->get_option('FAN_addShipTaxToRbs');
		$FAN_askForRbsInBankAccount = $this->get_option('FAN_askForRbsInBankAccount');
		$FAN_rbsPaymentAtDestination = $this->get_option('FAN_rbsPaymentAtDestination');
		$FAN_askForShipInsurance = $this->get_option('FAN_askForShipInsurance');
		$FAN_includeProductsCode = $this->get_option('FAN_includeProductsCode');
		$FAN_obsOnAWB = $this->get_option('FAN_obsOnAWB');
		$FAN_contactPerson = $this->get_option('FAN_contactPerson');		
		$FAN_openOnDelivery = $this->get_option('FAN_openOnDelivery');
		$FAN_epod = $this->get_option('FAN_epod');
		
		// -------------campuri modul STOP ----------------------
		
		$adresaDestinatar = $package['destination']['address'];
		$adresaDestinatar_2 = $package['destination']['address_2'];
                $orasDestinatar = $package['destination']['city'];
                $judetDestinatar = $package['destination']['state'];
		$codPostal = $package['destination']['postcode'];
		$totalWeight = round($woocommerce->cart->cart_contents_weight);
		$cartTotal = number_format( (float)( $woocommerce->cart->cart_contents_total + $woocommerce->cart->tax_total ), 0, '.', '' );
		$formmmatedCartTotal = number_format(round((float)$cartTotal,2), 2, '.', '');
		
		$billing_first_name = $woocommerce->session->get('billing_first_name');
		$billing_last_name = $woocommerce->session->get('billing_last_name');
		$billing_company = $woocommerce->session->get('billing_company');
		$billing_email = $woocommerce->session->get('billing_email');
		$billing_phone = $woocommerce->session->get('billing_phone');
				
		$observatii = $FAN_obsOnAWB;
		
		$judete = array (
		    
		    "AB" => "Alba",
		    "AR" => "Arad",
		    "AG" => "Arges",
		    "BC" => "Bacau",
		    "BH" => "Bihor",
		    "BN" => "Bistrita-Nasaud",
		    "BT" => "Botosani",
		    "BR" => "Braila",
		    "BV" => "Brasov",
		    "B"  => "Bucuresti",
		    "BZ" => "Buzau",
		    "CL" => "Calarasi",
		    "CS" => "Caras-Severin",
		    "CJ" => "Cluj",
		    "CT" => "Constanta",
		    "CV" => "Covasna",
		    "DB" => "Dambovita",
		    "DJ" => "Dolj",
		    "GL" => "Galati",
		    "GR" => "Giurgiu",
		    "GJ" => "Gorj",
		    "HR" => "Harghita",
		    "HD" => "Hunedoara",
		    "IL" => "Ialomita",
		    "IS" => "Iasi",
		    "IF" => "Ilfov",
		    "MM" => "Maramures",
		    "MH" => "Mehedinti",
		    "MS" => "Mures",
		    "NT" => "Neamt",
		    "OT" => "Olt",
		    "PH" => "Prahova",
		    "SJ" => "Salaj",
		    "SM" => "Satu Mare",
		    "SB" => "Sibiu",
		    "SV" => "Suceava",
		    "TR" => "Teleorman",
		    "TM" => "Timis",
		    "TL" => "Tulcea",
		    "VL" => "Valcea",
		    "VS" => "Vaslui",
		    "VN" => "Vrancea"
		    
		);
		
		foreach($judete as $key => $value)
		{
		    if($key == $package['destination']['state'])
		    {
			$judetDestinatar = $value; 
		    }		     
		}
		
     
		
		 //------------------------ Conditii FAN START----------------------------
	    
	    $is_enabled = $this->enabled;
	    
	    if($is_enabled == 'yes'){// daca este activat plugin FAN
	    
	    $min_gratuit = $FAN_freeShippingMinimumAmount;
	    $valoare_fixa = $FAN_countryFixedAmount;
	    $valoare_fixa_bucuresti = $FAN_bucFixedAmount;
	    $localitate_dest = $orasDestinatar;
            $judet_dest = $judetDestinatar;
	    
	        if (is_numeric($min_gratuit)) $min_gratuit = $min_gratuit + 0; else $min_gratuit = 0 + 0;
                        
						
						if (is_numeric($valoare_fixa)) $valoare_fixa = $valoare_fixa + 0; else $valoare_fixa = 0 + 0;
                        //sfarsit valoare fixa
                        
						
						if (is_numeric($valoare_fixa_bucuresti)) $valoare_fixa_bucuresti = $valoare_fixa_bucuresti + 0; else $valoare_fixa_bucuresti = 0 + 0;
                        //sfarsit valoare fixa
											
						//$link_standard="";
	    
	    
		if($FAN_parcelShipping == 'yes'){// expediere colete
		    $plic = "0";
		    if (is_numeric($FAN_numberOfParcels)){// numar pachere/AWB
                                $colet = $FAN_numberOfParcels;
                            } else {
                                $colet = 1;
                            }
		}else{
		    
		     $colet = "0";
                            if (is_numeric($FAN_numberOfParcels)){
                                $plic = $FAN_numberOfParcels;
                            } else {
                                $plic = 1;
                            }
		}
				
		 if ($FAN_addShipTaxToRbs == 'yes'){// adaugare taxa transport la ramburs
                            $totalrb = "1";
                        } else {
                            $totalrb = "0";
                        }

		if( $FAN_askForShipInsurance == 'yes' ){// solicitare asigurare de transport
			$valoaredeclarata = $cartTotal;
		    }else{
			$valoaredeclarata = 0;
			}
			
		$greutate = $totalWeight;
		if ($greutate>1)
		    {
			    $plic=0;
			    if (is_numeric($FAN_numberOfParcels))
			    {
				    $colet=$FAN_numberOfParcels;
			    } 
			    else 
			    {
				    $colet=1;
			    }
		    }
		
		 if (round((float)$totalWeight,0)>5){// daca greutate > 5, nu face REDCODE
		    $redcode = false;
		 }
		 
		 
		$lungime = 0;
		$latime = 0;
		$inaltime = 0;
		
		if($FAN_paymentAtDestination == 'yes'){// plata AWB la destinatie
		    $plata_expeditiei = "destinatar";
                }else{
                    $plata_expeditiei = "expeditor";
                }
		
		 $rambursare = '';
                 $rambursare_number = 0 + 0;
                 $plata_expeditiei_ramburs = "";
		 
		 
		  if ((strtolower($localitate_dest) == "bucuresti") and is_numeric($valoare_fixa_bucuresti)){// valoare fixa transport in Bucuresti
		    
                      $valoare_fixa = $valoare_fixa_bucuresti;
		  }
		  
		  //----------------------- Solicita Ramburs valoare marfa START -----------------------------
		  
		  if ($FAN_askForRbsGoodsValue == 'yes'){ //solicitare ramburs valoare marfa
		    
			if ($FAN_askForRbsInBankAccount == 'yes' ){ //solicitare ramburs in cont bancar
			    
			    $rambursare = number_format(round((float)$cartTotal,2), 2, '.', '');
			    $rambursare_number = round((float)$cartTotal,2)+0;                                          
			    
			    if ($min_gratuit < $rambursare_number and $min_gratuit != 0){ // suma minima transport gratuit							
				$totalrb = "0";
			    }
								       
			    if ($FAN_rbsPaymentAtDestination == 'yes'){ // plata AWB la destinatie
				$plata_expeditiei_ramburs = "destinatar";
			    }else{
				$plata_expeditiei_ramburs = "expeditor";
			    }
			    
			}else{                                       	
				$rambursare = (string)number_format(round((float)$cartTotal,2), 2, '.', '')." LEI";
				$rambursare_number = round((float)$cartTotal,2) + 0;
																				    
				if ($min_gratuit < $rambursare_number and $min_gratuit != 0){// suma minima transport gratuit
				    $totalrb = "0";
				}
				
				if ($FAN_rbsPaymentAtDestination == 'yes'){// plata AWB la destinatie
				    $plata_expeditiei_ramburs = "destinatar";
				}else{
				    $plata_expeditiei_ramburs = "expeditor";
				}
                            }
                    }else{
			    $rambursare_number = round((float)$cartTotal,2)+0;
			}
			
	    
		//------------------------------- Solicita Ramburs valoare marfa STOP ----------------------------- 
		if ($min_gratuit < $rambursare_number and $min_gratuit != 0)//cand min gratuit mai mic ca ramburs trec automat plata la expeditor
		    {
			    $plata_expeditiei="expeditor";
		    }
		
		
		
		if ($judet_dest == "Satu-Mare")
		{
		    $judet_dest = "Satu Mare";
		}

		if ($judet_dest == "Dimbovita")
		{
		    $judet_dest = "Dambovita";
		}
		
		 $continut = '';
		 
		 foreach ( $package['contents'] as  $values ) {
		    if ( $values['data']->needs_shipping() ) {
			    $continut = $continut.$values['quantity']." X ".$values['data']->get_title().", " ; // populez variabila $continut cu produsele care necesita livrare
			    
		    }
		}
		
		//---------- Preluare adresa, nume, telefon, email START --------------
		     if(trim($billing_company)!=''){
			    $nume_destinatar = $billing_company;
			    $persoana_contact =  $billing_first_name." ".$billing_last_name;
			  
			}else{
			    $nume_destinatar = $billing_first_name." ".$billing_last_name;
			    
			    $persoana_contact = $billing_first_name." ".$billing_last_name;
			    
			    if (trim($persoana_contact) == trim($persoana_contact)){
				$persoana_contact = '';
				}
			}
														    
                                  
                    $telefon = $billing_phone ;   
		    $email = $billing_email;	
		    $strada = $adresaDestinatar;
		    $strada = rawurlencode($strada);
		    
		    $temp_adress = $adresaDestinatar_2;
		    $temp_adress = rawurlencode($temp_adress);
		    
		    $strada = $strada.", ".$temp_adress;
				
		    $postalcode = str_pad( $codPostal, 6 ,"0");
		    
		    
		    if($FAN_confirmAWB == "yes"){
			$onlyadm = 1;
		    }else{
			$onlyadm = 0;
		    }
		    
		    if($FAN_priceWithoutVAT == "yes" ){
			$fara_tva = 1;
		    }else{
			$fara_tva = 0;
		    }
		    
		    if($FAN_priceForExtraKm == "yes"){
			$doar_km = 1;
		    }else{
			$doar_km = 0;
		    }
		    
		    $optiuni='';
		    
		    if($FAN_openOnDelivery == "yes"){
			$optiuni .= "A";
		    }
		    
		    if($FAN_epod == "yes"){
			$optiuni .= "X";
		    }
		//---------- Preluare adresa, nume, telefon, email STOP --------------
			
		$url = 'http://www.selfawb.ro/order.php';
                $c = curl_init ($url);
                curl_setopt ($c, CURLOPT_POST, true);
                curl_setopt ($c, CURLOPT_POSTFIELDS, "username=$FAN_clientAccount&user_pass=$FAN_password&client_id=$FAN_clientId&return=services");
                curl_setopt ($c, CURLOPT_RETURNTRANSFER, true);
                $page = curl_exec ($c);
                curl_close ($c);
		


		$servicii_data = explode("\n",ltrim(rtrim($page))); // COMPATIBIL PENTRU VERSIUNE PHP < 5.2.X

			   foreach($servicii_data as $tip_serviciu_info){
			       $tip_serviciu_info = str_replace('"','',$tip_serviciu_info);
			       
			       if (($FAN_askForRbsInBankAccount=="no" or $FAN_askForRbsGoodsValue == "no")){
				   $tip_serviciu = explode(",",$tip_serviciu_info);
				   if ($tip_serviciu[1] == 0 and (($tip_serviciu[2] == 0 and $tip_serviciu[3] == 0) or ($tip_serviciu[2] == 1 and $FAN_redCodeOption == "yes") or ($tip_serviciu[3] == 1 and $FAN_expressLocoOption == "yes"))){
					   $url = 'http://www.selfawb.ro/order.php';
					   $c = curl_init ($url);
					   curl_setopt ($c, CURLOPT_POST, true);
					   curl_setopt ($c, CURLOPT_POSTFIELDS, "username=$FAN_clientAccount&user_pass=$FAN_password&client_id=$FAN_clientId&plata_expeditiei=$plata_expeditiei&tip_serviciu=$tip_serviciu[0]&localitate_dest=
										    $localitate_dest&judet_dest=$judet_dest&plic=$plic&colet=$colet&greutate=$greutate&lungime=$lungime&latime=$latime&inaltime=$inaltime&valoare_declarata=
										    $valoaredeclarata&plata_ramburs=$plata_expeditiei_ramburs&ramburs=$rambursare&pers_contact_expeditor=$FAN_contactPerson&observatii=$observatii&continut=
										    $continut&nume_destinatar=$nume_destinatar&persoana_contact=$persoana_contact&telefon=$telefon&email=$email&strada=$strada&postalcode=$postalcode&totalrb=
										    $totalrb&admin=$onlyadm&fara_tva=$fara_tva&suma_fixa=$valoare_fixa&doar_km=$doar_km&optiuni=$optiuni");
					   curl_setopt ($c, CURLOPT_RETURNTRANSFER, true);
					   $page = curl_exec ($c);
					   curl_close ($c);
					   $price = explode("|||",$page);
					   if (isset($price[1])) {
					       
					       if (($FAN_hideShippingRate == "no") and ($min_gratuit > $rambursare_number or $min_gratuit == 0)) 
					       {
					       $price_standard = $price[0]; 														
					       }
					       else 
					       $price_standard = 0;
					       
					       $link_standard = $price[1];
					      
					   } else {
					       $price_standard = "";
					   }
						    
				    if(is_user_logged_in()){ //daca user e logat
					   
					   if (is_numeric($price_standard) and $link_standard!=""){// daca am adresa corecta afisez TIP SERVICIU si PRET
						   $args = array(
								'id' 	=> $this->id,
								'label' => "<a href=\"http://www.selfawb.ro/order.php?order_id=$link_standard\" target=\"_blank\">$tip_serviciu[0]</a>",
								'cost' 	=> $price_standard,
								'taxes' => false
							);
						      $this->add_rate($args);
						  
					   }else{// daca NU am adresa corecta afisez mesaj eroare
						   if ($tip_serviciu[2] == 0 and $tip_serviciu[3] == 0){
						       
						    $args = array();
						    $this->add_rate($args);
						      
						   }
					   }
				    }else{ // daca user NU e logat START
					
					 if (is_numeric($price_standard) and $link_standard!=""){// daca am adresa corecta afisez TIP SERVICIU si PRET  dar FARA LINK
						   $args = array(
								'id' 	=> $this->id,
								'label' => $tip_serviciu[0],
								'cost' 	=> $price_standard,
								'taxes' => false
							);
						      $this->add_rate($args);
						  
					   }else{ // daca NU am adresa corecta afisez mesaj eroare
						   if ($tip_serviciu[2] == 0 and $tip_serviciu[3] == 0){
						       
						    $args = array();
						    $this->add_rate($args);

						   }
					   }
					
					
					
					}  //daca nu e logat END 
				   }
				   unset($tip_serviciu);
			       } else {
				   $tip_serviciu = explode(",",$tip_serviciu_info);
				   if ($tip_serviciu[1] == 1 and (($tip_serviciu[2] == 0 and $tip_serviciu[3] == 0) or ($tip_serviciu[2] == 1 and $FAN_redCodeOption == 'yes') or ($tip_serviciu[3] == 1 and $FAN_expressLocoOption == 'yes'))){
					   $url = 'http://www.selfawb.ro/order.php';
					   $c = curl_init ($url);
					   curl_setopt ($c, CURLOPT_POST, true);
					   curl_setopt ($c, CURLOPT_POSTFIELDS, "username=$FAN_clientAccount&user_pass=$FAN_password&client_id=$FAN_clientId&plata_expeditiei=$plata_expeditiei&tip_serviciu=$tip_serviciu[0]&localitate_dest=
										    $localitate_dest&judet_dest=$judet_dest&plic=$plic&colet=$colet&greutate=$greutate&lungime=$lungime&latime=$latime&inaltime=$inaltime&valoare_declarata=
										    $valoaredeclarata&plata_ramburs=$plata_expeditiei_ramburs&ramburs=$rambursare&pers_contact_expeditor=$FAN_contactPerson&observatii=$observatii&continut=
										    $continut&nume_destinatar=$nume_destinatar&persoana_contact=$persoana_contact&telefon=$telefon&email=$email&strada=$strada&postalcode=$postalcode&totalrb=
										    $totalrb&admin=$onlyadm&fara_tva=$fara_tva&suma_fixa=$valoare_fixa&doar_km=$doar_km&optiuni=$optiuni");
					   curl_setopt ($c, CURLOPT_RETURNTRANSFER, true);
					   $page = curl_exec ($c);
					   curl_close ($c);
					   $price = explode("|||",$page);
					   if (($FAN_hideShippingRate == "no") and ($min_gratuit > $rambursare_number or $min_gratuit == 0)) $price_standard = $price[0]; else $price_standard = 0;
					   if (isset($price[1])) {
					       if (($FAN_hideShippingRate == "no") and ($min_gratuit > $rambursare_number or $min_gratuit == 0)) 
					       {
					       $price_standard = $price[0]; 														
					       }
					       else 
					       $price_standard = 0;
					       
					       $link_standard = $price[1];
					       
					       
					   } else {
					       $price_standard = "";
					   }
                                     if(is_user_logged_in()){  /// daca e logat
					   if (is_numeric($price_standard) and $link_standard!=""){ // daca am adresa corecta afisez TARIF si PRET cu link
					    
					    $args = array(
							    'id' 	=> $this->id,
							    'label'     => "<a href=\"http://www.selfawb.ro/order.php?order_id=$link_standard\" target=\"_blank\">$tip_serviciu[0]  </a>",
							    'cost' 	=> $price_standard,
							    'taxes'     => false
						    );
						   $this->add_rate($args);
						  
					   }else{// daca nu am adresa corecta afisez mesaj eroare
						   if ($tip_serviciu[2] == 0 and $tip_serviciu[3] == 0){
						    
						    $args = array();
						    $this->add_rate($args);
						            
						   }
					   }
					   
				      }else{//daca nu e logat START
					
					 if (is_numeric($price_standard) and $link_standard!=""){// daca user NU e logat si are adresa corecta afisez TIP SERVICIU si PRET fara link 
					    
					    $args = array(
							    'id' 	=> $this->id,
							    'label'     => $tip_serviciu[0],
							    'cost' 	=> $price_standard,
							    'taxes'     => false
						    );
						   $this->add_rate($args);
						  
					   }else{//  daca adresa e incorecta afisez mesaj de eroare
						   if ($tip_serviciu[2] == 0 and $tip_serviciu[3] == 0){
						    
						    $args = array();
						   $this->add_rate($args);
						       
						   }
					   }
					
					
					
					} //daca nu e logat END
				   }
				   unset($tip_serviciu);
			       }
			   }
       
		
		    
	    }	
	    //------------------------ Conditii FAN STOP----------------------------
	   
	 
        }
	
		
	
    }
    
    }
    
   add_action( 'woocommerce_shipping_init', 'fan_courier_init' );
    
    function add_fan_courier_method($methods) {
    	$methods[] = 'WC_FAN_Courier';
	return $methods;
    }
    
   add_filter('woocommerce_shipping_methods', 'add_fan_courier_method');
    
    
    
  //  function fan_scripts_method() {
   //     $url = plugins_url();
   //     wp_enqueue_script(
   //         'jquery_ui',
    //        $url.'/fan_courier/jqueryui.min.js',
   // 		array('jquery')
    //    );
    //    wp_enqueue_script(
    //        'fan_autocomplete',
    //        $url.'/fan_courier/front_autocomplete.js',
    //		array('jquery')
    //    );
   // }
    
   // add_action('wp_enqueue_scripts', 'fan_scripts_method');
    
           

    
    
}




